require 'rack/cors'
module HousingMisc
  class Railtie < Rails::Railtie

    # middleware for support of CORS for housing subdomains
    initializer "housing_misc.insert_middleware" do |app|
      rails_version = Gem.loaded_specs["rails"].version
      rails_5 = Gem::Version.create('5.0')
      rack_cors = rails_version >= rails_5 ? Rack::Cors : "Rack::Cors"
      app.config.middleware.insert_before 0, rack_cors do
        allow do
          origins { |source, env| env["HTTP_ORIGIN"].match?(Regexp.new (HousingMisc.origin || '\A^https?:\/\/([a-zA-Z0-9\-\.]+[.])*housing.com\z')) }
          resource '*', :headers => :any, :credentials=> eval(HousingMisc.credentials_flag.to_s) || true, :methods => [:get, :post, :put, :delete, :options], expose: HousingMisc.expose_headers || "", max_age: HousingMisc.max_age || 86400
        end
      end
    end

    # middleware for introducing global request id
    # not required once we move to rails 5 or beyond 
    initializer "housing_misc.insert_request_tracer_middleware" do |app|
      app.config.middleware.insert_after ActionDispatch::RequestId, RequestTracer
    end
  end
end
